#
# Conditional build:
%bcond_without	doc	# API documentation
%bcond_without	tests	# unit tests

Summary:	Yet another URL library
Summary(pl.UTF-8):	Yet another URL library - jeszcze jedna biblioteka do URL-i
Name:		python3-yarl
Version:	1.19.0
Release:	2
License:	Apache v2.0
Group:		Libraries/Python
#Source0Download: https://pypi.org/simple/yarl/
Source0:	https://files.pythonhosted.org/packages/source/y/yarl/yarl-%{version}.tar.gz
# Source0-md5:	caef211f38f3d8c8fcc94bd78349f4e2
URL:		https://pypi.org/project/yarl/
BuildRequires:	python3-Cython >= 3.0.11
BuildRequires:	python3-build
BuildRequires:	python3-devel >= 1:3.7
BuildRequires:	python3-expandvars
BuildRequires:	python3-installer
%if %{with tests}
BuildRequires:	python3-idna >= 2.0
BuildRequires:	python3-multidict >= 4.0
BuildRequires:	python3-propcache
BuildRequires:	python3-pytest >= 3.8.2
BuildRequires:	python3-pytest-benchmark
BuildRequires:	python3-pytest-cov
BuildRequires:	python3-pytest-xdist
%if "%{py3_ver}" == "3.7"
BuildRequires:	python3-typing_extensions >= 3.7.4
%endif
%endif
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 2.044
%if %{with doc}
BuildRequires:	python3-alabaster
BuildRequires:	python3-sphinxcontrib-towncrier
BuildRequires:	sphinx-pdg-3
%endif
Requires:	python3-modules >= 1:3.7
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Yet another URL library.

%description -l pl.UTF-8
YARL (Yet another URL library) to jeszcze jedna biblioteka do URL-i.

%package apidocs
Summary:	API documentation for Python yarl module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona yarl
Group:		Documentation
BuildArch:	noarch

%description apidocs
API documentation for Python yarl module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona yarl.

%prep
%setup -q -n yarl-%{version}

# keep *.c files so debuginfo will pick it up
sed -i -e 's#build_inplace: bool = False,#build_inplace: bool = True,#g' -e 's#build_inplace=False#build_inplace=True#g' packaging/pep517_backend/_backend.py

%build
%py3_build_pyproject

%if %{with tests}
%{__python} -m zipfile -e build-3/*.whl build-3-test
# run from dir not containing yarl source dir without compiled yarl._quoting_c module)
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTEST_PLUGINS="benchmark,xdist" \
%{__python3} -m pytest -o pythonpath="$PWD/build-3-test" tests
%endif

%if %{with doc}
%{__make} -C docs html \
	SPHINXBUILD=sphinx-build-3
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py3_install_pyproject

%{__rm} $RPM_BUILD_ROOT%{py3_sitedir}/yarl/_quoting_c.pyx

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc CHANGES.rst README.rst
%dir %{py3_sitedir}/yarl
%attr(755,root,root) %{py3_sitedir}/yarl/_quoting_c.cpython-*.so
%{py3_sitedir}/yarl/*.py
%{py3_sitedir}/yarl/py.typed
%{py3_sitedir}/yarl/__pycache__
%{py3_sitedir}/yarl-%{version}.dist-info

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/_build/html/{_static,*.html,*.js}
%endif
%changelog
* Mon Apr 07 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-yarl.git;a=log;h=master

* Mon Apr 07 2025 Jan Rękorajski <baggins@pld-linux.org> 363c03d
- Release 2 (by relup.sh)

* Mon Apr 07 2025 Jan Rękorajski <baggins@pld-linux.org> 89e401b
- BR python3-sphinxcontrib-towncrier for docs

* Mon Apr 07 2025 Jan Rękorajski <baggins@pld-linux.org> 99e745a
- up to 1.19.0

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 0c23ff4
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> c72dd17
- python 3.13 rebuild

* Wed Feb 19 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> a379c8b
- Rel 3; keep .c files

* Wed Feb 19 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> 7c788ba
- tests: BR: python3-propcache

* Wed Feb 19 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> 56f6f03
- BR python3-Cython >= 3.0.11

* Mon Feb 10 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> 43a2f54
- Fix tests

* Sat Feb 08 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> 22c8833
- Up to 1.18.3

* Tue Feb 28 2023 Jan Palus <atler@pld-linux.org> da3054e
- rpm version for noarch subpackage

* Tue Feb 28 2023 Jan Palus <atler@pld-linux.org> 32f665d
- up to 1.8.2

* Mon Sep 12 2022 Jakub Bogusz <qboosh@pld-linux.org> d338adf
- updated to 1.8.1

* Sun Apr 10 2022 Jan Rękorajski <baggins@pld-linux.org> ab02ea3
- Release 4 (by relup.sh)

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> d85c081
- rebuild with tests and docs

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> f5fd74d
- rebuild with python 3.10

* Thu Nov 25 2021 Jan Rękorajski <baggins@pld-linux.org> 69ecdff
- up to 1.7.2

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> 10115f2
- rebuild with separate debuginfo build-ids

* Sun Mar 07 2021 Jan Rękorajski <baggins@pld-linux.org> 8462ccb
- unconditional noarch subpackages

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> 073d303
- release 2 (by relup.sh)

